/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.entschaedigung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.entschaedigung.boundary.AbstractAuszahlungSearchParameters;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungChangeEvent;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungConversationStore;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungExtendedDAO;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungSearch;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.entschaedigung.entity.Auszahlung;
import de.ivu.elect.business.entschaedigung.entity.AuszahlungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractAuszahlungSearchView.COMPONENT_NAME)
@View(viewId = AbstractAuszahlungSearchView.VIEW_ID, useCase = UseCasePermission.AUSZAHLUNG_SEARCH)
public abstract class AbstractAuszahlungSearchView extends AbstractElectSearchView<Auszahlung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "auszahlungSearchView";
  
  public static final String VIEW_ID = "/entschaedigung/auszahlung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractAuszahlungSearchView requestHandler;

  @Inject
  private transient AuszahlungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(AuszahlungConversationStore.class)
  protected transient AuszahlungConversationStore conversationStore;

  @Inject
  protected transient AuszahlungSearch search;

  @Inject
  @ConversationGroup(AbstractAuszahlungSearchParameters.class)
  protected transient AuszahlungSearchParameters searchParameters;

  @Inject
  protected transient AuszahlungMeta entityMeta;

  public AbstractAuszahlungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Auszahlung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Auszahlung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public AuszahlungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Auszahlung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Auszahlung> create();
  }

  @Override
  public List<Auszahlung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Auszahlung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onAuszahlungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) AuszahlungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractAuszahlungSearchView {

    @View
    @Inject
    private transient Instance<AbstractAuszahlungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractAuszahlungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
